import Component from '@glimmer/component';

export default class CircleChartComponent extends Component {
  // @values - Param - array of percents

  fillerColors = ['#556B2F', '#FAEBD7', '#00FFFF', '#7FFFD4', '#F0FFFF', '#8A2BE2'];

  get strokeWidth() {
    return this.args.strokeWidth ? this.args.strokeWidth : '3'
  }

  get colors() {
    return this.args.colors ? this.args.colors : this.args.values.map((_, index) => {
      return this.fillerColors[index]
    });
  }

  // Where do the $ segments start - 25 is starting from top
  get startingOffset() {
    return this.args.startingOffset ? this.args.startingOffset : 25;
  }

  get segments() {
    return this.args.values
      ? this.args.values.reduce((segments, value, index) => {
        return [...segments, {
          color: this.colors[index],
          dasharray: `${value} ${100 - value}`,
          dashoffset: segments.reduce((offset, segment) => offset - segment.value, this.startingOffset),
          value
        }]
      }, [])
      : []
  }
}