import Component from '@glimmer/component';
import { tracked } from '@glimmer/tracking';


export default class LineChartComponent extends Component {
  @tracked lineElement;

  get isLoaded() {
    return (this.args.dataset || this.args.dataset === []) && !!this.args.dimensions;
  }

  get fill() {
    return this.args.fill ? this.args.fill : 'none'
  }

  get color() {
    return this.args.color ? this.args.color : 'black'
  }

  get strokeWidth() {
    return this.args.strokeWidth ? this.args.strokeWidth : '2'
  }

  get xKey() {
    return this.args.xKey ? this.args.xKey : 'at';
  }

  get yKey() {
    return this.args.yKey ? this.args.yKey : 'value';
  }

  get currentLineInfo() {
    if(!this.isLoaded) return {}
    return this.generateSVGLine(this.args.xScale, this.args.yScale, this.args.dataset)
  }

  generateSVGLine(xScale, yScale, dataset) {
    const xKey = this.xKey;
    const yKey = this.yKey;
    if(!dataset || dataset.length === 0) return ""
    return `M${xScale(dataset[0][xKey])} ${yScale(dataset[0][yKey])} 
            ${dataset.slice(1).map(d => {
              return `L${xScale(d[xKey])} ${yScale(d[yKey])}`;
            }).join(' ')}`
  }
}